---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_address_family_ipv6_vrf Data Source - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This data source can read the BGP Address Family IPv6 VRF configuration.
---

# iosxe_bgp_address_family_ipv6_vrf (Data Source)

This data source can read the BGP Address Family IPv6 VRF configuration.

## Example Usage

```terraform
data "iosxe_bgp_address_family_ipv6_vrf" "example" {
  asn     = "65000"
  af_name = "unicast"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `af_name` (String)

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `asn` (String)
- `id` (String) The path of the retrieved object.
- `vrfs` (Attributes List) (see [below for nested schema](#nestedatt--vrfs))

<a id="nestedatt--vrfs"></a>
### Nested Schema for `vrfs`

Read-Only:

- `advertise_l2vpn_evpn` (Boolean) Advertise/export prefixes to l2vpn evpn table
- `name` (String)
- `redistribute_connected` (Boolean) Connected
- `redistribute_static` (Boolean) Static routes


