---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_interface_nve Data Source - terraform-provider-iosxe"
subcategory: "Interface"
description: |-
  This data source can read the Interface NVE configuration.
---

# iosxe_interface_nve (Data Source)

This data source can read the Interface NVE configuration.

## Example Usage

```terraform
data "iosxe_interface_nve" "example" {
  name = 1
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `name` (Number)

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `description` (String) Interface specific description
- `host_reachability_protocol_bgp` (Boolean)
- `id` (String) The path of the retrieved object.
- `shutdown` (Boolean) Shutdown the selected interface
- `source_interface_loopback` (Number) Loopback interface
- `vni_vrfs` (Attributes List) Configure VNI information (see [below for nested schema](#nestedatt--vni_vrfs))
- `vnis` (Attributes List) Configure VNI information (see [below for nested schema](#nestedatt--vnis))

<a id="nestedatt--vni_vrfs"></a>
### Nested Schema for `vni_vrfs`

Read-Only:

- `vni_range` (String) VNI range or instance between 4096-16777215, example: 6010-6030 or 7115
- `vrf` (String) Specify a particular VRF


<a id="nestedatt--vnis"></a>
### Nested Schema for `vnis`

Read-Only:

- `ingress_replication` (Boolean) Ingress Replication control-plane (BGP) signaling
- `ipv4_multicast_group` (String) Starting Multicast Group IPv4 Address
- `vni_range` (String) VNI range or instance between 4096-16777215, example: 6010-6030 or 7115


