---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_neighbor Resource - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This resource can manage the BGP Neighbor configuration.
---

# iosxe_bgp_neighbor (Resource)

This resource can manage the BGP Neighbor configuration.

## Example Usage

```terraform
resource "iosxe_bgp_neighbor" "example" {
  asn                    = "65000"
  ip                     = "3.3.3.3"
  remote_as              = "65000"
  description            = "BGP Neighbor Description"
  shutdown               = false
  update_source_loopback = 100
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `asn` (String)
- `ip` (String)

### Optional

- `description` (String) Neighbor specific description
- `device` (String) A device name from the provider configuration.
- `remote_as` (String) Specify a BGP peer-group remote-as
- `shutdown` (Boolean) Administratively shut down this neighbor
- `update_source_loopback` (Number) Loopback interface

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_bgp_neighbor.example "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/neighbor=3.3.3.3"
```
