---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_interface_loopback Resource - terraform-provider-iosxe"
subcategory: "Interface"
description: |-
  This resource can manage the Interface Loopback configuration.
---

# iosxe_interface_loopback (Resource)

This resource can manage the Interface Loopback configuration.

## Example Usage

```terraform
resource "iosxe_interface_loopback" "example" {
  name              = 100
  description       = "My Interface Description"
  shutdown          = false
  vrf_forwarding    = "VRF1"
  ipv4_address      = "200.1.1.1"
  ipv4_address_mask = "255.255.255.255"
  pim_sparse_mode   = true
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `name` (Number) - Range: `0`-`2147483647`

### Optional

- `description` (String) Interface specific description
- `device` (String) A device name from the provider configuration.
- `ipv4_address` (String)
- `ipv4_address_mask` (String)
- `pim_sparse_mode` (Boolean) Enable PIM sparse-mode operation
- `shutdown` (Boolean) Shutdown the selected interface
- `vrf_forwarding` (String) Configure forwarding table

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_interface_loopback.example "Cisco-IOS-XE-native:native/interface/Loopback=100"
```
