---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_interface_nve Resource - terraform-provider-iosxe"
subcategory: "Interface"
description: |-
  This resource can manage the Interface NVE configuration.
---

# iosxe_interface_nve (Resource)

This resource can manage the Interface NVE configuration.

## Example Usage

```terraform
resource "iosxe_interface_nve" "example" {
  name                           = 1
  description                    = "My Interface Description"
  shutdown                       = false
  host_reachability_protocol_bgp = true
  source_interface_loopback      = 100
  vnis = [
    {
      vni_range            = "10000"
      ipv4_multicast_group = "225.1.1.1"
    }
  ]
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `name` (Number) - Range: `1`-`4096`

### Optional

- `description` (String) Interface specific description
- `device` (String) A device name from the provider configuration.
- `host_reachability_protocol_bgp` (Boolean)
- `shutdown` (Boolean) Shutdown the selected interface
- `source_interface_loopback` (Number) Loopback interface
  - Range: `0`-`2147483647`
- `vni_vrfs` (Attributes List) Configure VNI information (see [below for nested schema](#nestedatt--vni_vrfs))
- `vnis` (Attributes List) Configure VNI information (see [below for nested schema](#nestedatt--vnis))

### Read-Only

- `id` (String) The path of the object.

<a id="nestedatt--vni_vrfs"></a>
### Nested Schema for `vni_vrfs`

Optional:

- `vni_range` (String) VNI range or instance between 4096-16777215, example: 6010-6030 or 7115
- `vrf` (String) Specify a particular VRF


<a id="nestedatt--vnis"></a>
### Nested Schema for `vnis`

Optional:

- `ingress_replication` (Boolean) Ingress Replication control-plane (BGP) signaling
- `ipv4_multicast_group` (String) Starting Multicast Group IPv4 Address
- `vni_range` (String) VNI range or instance between 4096-16777215, example: 6010-6030 or 7115

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_interface_nve.example "Cisco-IOS-XE-native:native/interface/nve=1"
```
