---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_static_route Resource - terraform-provider-iosxe"
subcategory: "Routing"
description: |-
  This resource can manage the Static Route configuration.
---

# iosxe_static_route (Resource)

This resource can manage the Static Route configuration.

## Example Usage

```terraform
resource "iosxe_static_route" "example" {
  prefix = "5.5.5.5"
  mask   = "255.255.255.255"
  next_hops = [
    {
      next_hop  = "6.6.6.6"
      metric    = 10
      global    = false
      name      = "Route1"
      permanent = true
      tag       = 100
    }
  ]
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `mask` (String)
- `prefix` (String)

### Optional

- `device` (String) A device name from the provider configuration.
- `next_hops` (Attributes List) (see [below for nested schema](#nestedatt--next_hops))

### Read-Only

- `id` (String) The path of the object.

<a id="nestedatt--next_hops"></a>
### Nested Schema for `next_hops`

Optional:

- `global` (Boolean) Next hop address is global
- `metric` (Number) - Range: `1`-`255`
- `name` (String) Specify name of the next hop
- `next_hop` (String)
- `permanent` (Boolean) permanent route
- `tag` (Number) Set tag for this route
  - Range: `1`-`4294967295`

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_static_route.example "Cisco-IOS-XE-native:native/ip/route/ip-route-interface-forwarding-list=5.5.5.5,255.255.255.255"
```
