---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_vrf Resource - terraform-provider-iosxe"
subcategory: "VRF"
description: |-
  This resource can manage the VRF configuration.
---

# iosxe_vrf (Resource)

This resource can manage the VRF configuration.

## Example Usage

```terraform
resource "iosxe_vrf" "example" {
  name                = "VRF1"
  description         = "VRF1 description"
  rd                  = "1:1"
  address_family_ipv4 = true
  address_family_ipv6 = true
  vpn_id              = "1:1"
  route_target_import = [
    {
      value     = "1:1"
      stitching = false
    }
  ]
  route_target_export = [
    {
      value     = "1:1"
      stitching = false
    }
  ]
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `name` (String) WORD;;VRF name

### Optional

- `address_family_ipv4` (Boolean) Address family
- `address_family_ipv6` (Boolean) Address family
- `description` (String) VRF specific description
- `device` (String) A device name from the provider configuration.
- `rd` (String) Specify Route Distinguisher
- `route_target_export` (Attributes List) Export Target-VPN community (see [below for nested schema](#nestedatt--route_target_export))
- `route_target_import` (Attributes List) Import Target-VPN community (see [below for nested schema](#nestedatt--route_target_import))
- `vpn_id` (String) Configure VPN ID in rfc2685 format

### Read-Only

- `id` (String) The path of the object.

<a id="nestedatt--route_target_export"></a>
### Nested Schema for `route_target_export`

Optional:

- `stitching` (Boolean) VXLAN route target set
- `value` (String) Value


<a id="nestedatt--route_target_import"></a>
### Nested Schema for `route_target_import`

Optional:

- `stitching` (Boolean) VXLAN route target set
- `value` (String) Value

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_vrf.example "Cisco-IOS-XE-native:native/vrf/definition=VRF1"
```
