// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"context"
	"fmt"

	"github.com/hashicorp/terraform-plugin-framework/diag"
	"github.com/hashicorp/terraform-plugin-framework/tfsdk"
	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/hashicorp/terraform-plugin-log/tflog"
)

type dataSourceEVPNInstanceType struct{}

func (t dataSourceEVPNInstanceType) GetSchema(ctx context.Context) (tfsdk.Schema, diag.Diagnostics) {
	return tfsdk.Schema{
		// This description is used by the documentation generator and the language server.
		MarkdownDescription: "This data source can read the EVPN Instance configuration.",

		Attributes: map[string]tfsdk.Attribute{
			"device": {
				MarkdownDescription: "A device name from the provider configuration.",
				Type:                types.StringType,
				Optional:            true,
			},
			"id": {
				MarkdownDescription: "The path of the retrieved object.",
				Type:                types.StringType,
				Computed:            true,
			},
			"evpn_instance_num": {
				MarkdownDescription: "evpn instance number",
				Type:                types.Int64Type,
				Required:            true,
			},
			"vlan_based_replication_type_ingress": {
				MarkdownDescription: "Ingress replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_replication_type_static": {
				MarkdownDescription: "Static replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_replication_type_p2mp": {
				MarkdownDescription: "p2mp replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_replication_type_mp2mp": {
				MarkdownDescription: "mp2mp replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_encapsulation": {
				MarkdownDescription: "Data encapsulation method",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_auto_route_target": {
				MarkdownDescription: "Automatically set a route-target",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_rd": {
				MarkdownDescription: "ASN:nn or IP-address:nn",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_route_target": {
				MarkdownDescription: "ASN:nn or IP-address:nn",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_route_target_both": {
				MarkdownDescription: "ASN:nn or IP-address:nn",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_route_target_import": {
				MarkdownDescription: "ASN:nn or IP-address:nn",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_route_target_export": {
				MarkdownDescription: "ASN:nn or IP-address:nn",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_ip_local_learning_disable": {
				MarkdownDescription: "Disable IP local learning from dataplane",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_ip_local_learning_enable": {
				MarkdownDescription: "Enable IP local learning from dataplane",
				Type:                types.BoolType,
				Computed:            true,
			},
			"vlan_based_default_gateway_advertise": {
				MarkdownDescription: "Advertise Default Gateway MAC/IP routes",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_based_re_originate_route_type5": {
				MarkdownDescription: "Re-originate route-type 5",
				Type:                types.BoolType,
				Computed:            true,
			},
		},
	}, nil
}

func (t dataSourceEVPNInstanceType) NewDataSource(ctx context.Context, in tfsdk.Provider) (tfsdk.DataSource, diag.Diagnostics) {
	provider, diags := convertProviderType(in)

	return dataSourceEVPNInstance{
		provider: provider,
	}, diags
}

type dataSourceEVPNInstance struct {
	provider provider
}

func (d dataSourceEVPNInstance) Read(ctx context.Context, req tfsdk.ReadDataSourceRequest, resp *tfsdk.ReadDataSourceResponse) {
	var config, state EVPNInstance

	// Read config
	diags := req.Config.Get(ctx, &config)
	resp.Diagnostics.Append(diags...)
	if resp.Diagnostics.HasError() {
		return
	}

	tflog.Debug(ctx, fmt.Sprintf("%s: Beginning Read", config.getPath()))

	res, err := d.provider.clients[config.Device.Value].GetData(config.getPath())
	if res.StatusCode != 404 {
		if err != nil {
			resp.Diagnostics.AddError("Client Error", fmt.Sprintf("Failed to retrieve object, got error: %s", err))
			return
		}

		state.fromBody(res.Res)
	}
	state.fromPlan(config)
	state.Id.Value = config.getPath()

	tflog.Debug(ctx, fmt.Sprintf("%s: Read finished successfully", config.getPath()))

	diags = resp.State.Set(ctx, &state)
	resp.Diagnostics.Append(diags...)
}
