// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"fmt"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type BGPL2VPNNeighbor struct {
	Device               types.String `tfsdk:"device"`
	Id                   types.String `tfsdk:"id"`
	Asn                  types.String `tfsdk:"asn"`
	AfName               types.String `tfsdk:"af_name"`
	Ip                   types.String `tfsdk:"ip"`
	Activate             types.Bool   `tfsdk:"activate"`
	SendCommunity        types.String `tfsdk:"send_community"`
	RouteReflectorClient types.Bool   `tfsdk:"route_reflector_client"`
}

func (data BGPL2VPNNeighbor) getPath() string {
	return fmt.Sprintf("Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=%v/address-family/no-vrf/l2vpn=%s/l2vpn-evpn/neighbor=%s", data.Asn.Value, data.AfName.Value, data.Ip.Value)
}

func (data BGPL2VPNNeighbor) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.Ip.Null && !data.Ip.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"id", data.Ip.Value)
	}
	if !data.Activate.Null && !data.Activate.Unknown {
		if data.Activate.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"activate", map[string]string{})
		}
	}
	if !data.SendCommunity.Null && !data.SendCommunity.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"send-community.send-community-where", data.SendCommunity.Value)
	}
	if !data.RouteReflectorClient.Null && !data.RouteReflectorClient.Unknown {
		if data.RouteReflectorClient.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"route-reflector-client", map[string]string{})
		}
	}
	return body
}

func (data *BGPL2VPNNeighbor) fromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "activate"); value.Exists() {
		data.Activate.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "send-community.send-community-where"); value.Exists() {
		data.SendCommunity.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "route-reflector-client"); value.Exists() {
		data.RouteReflectorClient.Value = true
	}
}

func (data *BGPL2VPNNeighbor) fromPlan(plan BGPL2VPNNeighbor) {
	data.Device = plan.Device
	data.Asn.Value = plan.Asn.Value
	data.AfName.Value = plan.AfName.Value
	data.Ip.Value = plan.Ip.Value
}
