// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"testing"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/resource"
)

func TestAccIosxeBGPL2VPNNeighbor(t *testing.T) {
	resource.Test(t, resource.TestCase{
		PreCheck:                 func() { testAccPreCheck(t) },
		ProtoV6ProviderFactories: testAccProtoV6ProviderFactories,
		Steps: []resource.TestStep{
			{
				Config: testAccIosxeBGPL2VPNNeighborPrerequisitesConfig + testAccIosxeBGPL2VPNNeighborConfig_all(),
				Check: resource.ComposeTestCheckFunc(
					resource.TestCheckResourceAttr("iosxe_bgp_l2vpn_neighbor.test", "ip", "3.3.3.3"),
					resource.TestCheckResourceAttr("iosxe_bgp_l2vpn_neighbor.test", "activate", "true"),
					resource.TestCheckResourceAttr("iosxe_bgp_l2vpn_neighbor.test", "send_community", "both"),
					resource.TestCheckResourceAttr("iosxe_bgp_l2vpn_neighbor.test", "route_reflector_client", "false"),
				),
			},
			{
				ResourceName:  "iosxe_bgp_l2vpn_neighbor.test",
				ImportState:   true,
				ImportStateId: "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/address-family/no-vrf/l2vpn=evpn/l2vpn-evpn/neighbor=3.3.3.3",
			},
		},
	})
}

const testAccIosxeBGPL2VPNNeighborPrerequisitesConfig = `
resource "iosxe_restconf" "PreReq0" {
  path = "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000"
  attributes = {
      id = "65000"
  }
}

resource "iosxe_restconf" "PreReq1" {
  path = "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/address-family/no-vrf/l2vpn=evpn"
  attributes = {
      af-name = "evpn"
  }
  depends_on = [iosxe_restconf.PreReq0, ]
}

resource "iosxe_restconf" "PreReq2" {
  path = "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/neighbor=3.3.3.3"
  attributes = {
      id = "3.3.3.3"
      remote-as = "65000"
  }
  depends_on = [iosxe_restconf.PreReq0, ]
}

`

func testAccIosxeBGPL2VPNNeighborConfig_minimum() string {
	return `
	resource "iosxe_bgp_l2vpn_neighbor" "test" {
		asn = "65000"
		af_name = "evpn"
		ip = "3.3.3.3"
  		depends_on = [iosxe_restconf.PreReq0, iosxe_restconf.PreReq1, iosxe_restconf.PreReq2, ]
	}
	`
}

func testAccIosxeBGPL2VPNNeighborConfig_all() string {
	return `
	resource "iosxe_bgp_l2vpn_neighbor" "test" {
		asn = "65000"
		af_name = "evpn"
		ip = "3.3.3.3"
		activate = true
		send_community = "both"
		route_reflector_client = false
  		depends_on = [iosxe_restconf.PreReq0, iosxe_restconf.PreReq1, iosxe_restconf.PreReq2, ]
	}
	`
}
